      subroutine init(xpos,xpos_old,xvel,ndim,nparts
     .  ,temperature,ell,dt)
      implicit none
      integer ndim,nparts
      real*8 xpos(ndim,nparts),xpos_old(ndim,nparts)
     .,xvel(ndim,nparts),temperature,ell,dt,temp
      real*8 rnd,drnd,vcm(3),v2cm
      integer i,la
      
      drnd=0.001d0
      call lattice(xpos,ndim,nparts,ell,drnd)
      do la=1,ndim
        vcm(la)=0.d0
      end do
      v2cm=0.d0
      do i=1,nparts
        do la=1,ndim
           xvel(la,i)=(rnd()-0.5d0)
           vcm(la)=vcm(la)+xvel(la,i)
           v2cm=v2cm+xvel(la,i)**2
        end do
      end do
      v2cm=v2cm/dfloat(ndim*nparts)
      do la=1,ndim
        vcm(la)=vcm(la)/nparts
        v2cm=v2cm-vcm(la)**2/dfloat(ndim)
      end do
      temp=sqrt(temperature/v2cm)
      do i=1,nparts
        do la=1,ndim
          xvel(la,i)=temp*(xvel(la,i)-vcm(la))
          xpos_old(la,i)=xpos(la,i)-xvel(la,i)*dt
        end do
      end do
      end
