      subroutine lattice(xpos,ndim,nparts,ell,drnd)
      implicit none
c
c        
c
      integer nparts,ndim
      real*8 xpos(ndim,nparts),ell,drnd
      integer isite,ix,iy,iz,i
      real*8 del,rnd
      include 'fpbc.cm'

      isite=(1.d0*nparts)**(1.d0/ndim)+1
      del=ell/(isite)
      if(ndim.eq.2) then
        do ix=1,isite
          do iy=1,isite
             i=ix+(iy-1)*isite
             if(i.le.nparts) then
                xpos(1,i)=fpbc(del*(ix+drnd*(rnd()-0.5d0)),ell)
                xpos(2,i)=fpbc(del*(iy+drnd*(rnd()-0.5d0)),ell)
             end if
          end do
        end do
      else if(ndim.eq.3) then
        do ix=1,isite
          do iy=1,isite
            do iz=1,isite
              i=ix+(iy-1)*isite+(iz-1)*isite**2
              if(i.le.nparts) then
                xpos(1,i)=fpbc(del*(ix+drnd*(rnd()-0.5d0)),ell)
                xpos(2,i)=fpbc(del*(iy+drnd*(rnd()-0.5d0)),ell)
                xpos(3,i)=fpbc(del*(iz+drnd*(rnd()-0.5d0)),ell)
              end if
            end do
          end do
        end do
      else
        write(6,*)' dimension not implemented '
        stop
      end if
      end
            


