      program md
      implicit none
      integer ndim,nparts
      parameter (ndim=3,nparts=108)
      real*8 temperature, temperature_act
      real*8 ekin,upot,ell,rho
      real*8 xpos(ndim,nparts,3),xvel(ndim,nparts)
     .,force(ndim,nparts),t,rcut2,dt
      integer ib,i,isteps,it,it_old,it_new,itdummy
      real*8 umean,kmean
 
      rho=0.8442
      ell=(dfloat(nparts)/rho)**(1.d0/ndim)
      rcut2=(ell/2)**2
      temperature=0.728d0
      dt=0.001
      isteps=1000

      write(*,*)' L=',ell,' N=',nparts
      it_old=1
      it=2
      it_new=3
      t=0.d0

      call init(xpos(1,1,it),xpos(1,1,it_old),xvel,ndim,nparts
     .  ,temperature,ell,dt)

     
      
      open(1,file='md.dat')
      do ib=1,100
        umean=0.d0
        kmean=0.d0
        do i=1,isteps
          call forces(xpos(1,1,it),force,ndim,nparts,upot
     .       ,ell,rcut2)
          umean=umean+upot
          call verlet(xpos(1,1,it),xpos(1,1,it_new)
     .     ,xpos(1,1,it_old),force
     .     ,xvel,ndim,nparts,dt,ekin,temperature_act,ell)
          kmean=kmean+ekin
          t=t+dt
          itdummy=it_new
          it_new=it_old
          it_old=it
          it=itdummy
        end do
        write(6,*)' iblock=',ib,' temperature_act=',temperature_act
        umean=umean/float(nparts*isteps)
        kmean=kmean/float(nparts*isteps)
        write(1,*)t,umean+kmean,umean,kmean,temperature_act
        call flush(1)
      end do
      end
