      subroutine forces(xpos,force,ndim,nparts,utot
     .       ,ell,rcut2)
      implicit none
      integer ndim,nparts
      real*8 xpos(ndim,nparts),force(ndim,nparts),utot
      real*8 ell,rcut2,dr(3),r2,pot,ffsr,ecut
      integer i,la,j
      include 'fpbc.cm'

      call vpot(rcut2,pot,ffsr)
      ecut=pot
      do i=1,nparts
        do la=1,ndim
          force(la,i)=0.d0
        end do
      end do
      utot=0.d0
      do i=1,nparts
        do j=1,i-1
           r2=0.d0
           do la=1,ndim
             dr(la)=fpbc(xpos(la,i)-xpos(la,j),ell)
             r2=r2+dr(la)**2
           end do
           if(r2.lt.rcut2) then
             call vpot(r2,pot,ffsr)
             do la=1,ndim
                force(la,i)=force(la,i)-ffsr*dr(la)
                force(la,j)=force(la,j)+ffsr*dr(la)
             end do
             utot=utot+pot-ecut       
           end if
        end do
      end do
      end
           
