      subroutine verlet(xpos,xpos_new,xpos_old,force
     . ,xvel,ndim,nparts,dt,ekin,temperature_act,ell)
      implicit none
      integer ndim,nparts
      real*8 xpos(ndim,nparts),xpos_old(ndim,nparts)
     .,xpos_new(ndim,nparts),xvel(ndim,nparts),dt
     .,ekin,temperature_act,force(ndim,nparts),ell
      integer i,la
c
c        using Verlet
c
      ekin=0.d0
      do i=1,nparts
        do la=1,ndim
          xpos_new(la,i)=2.d0*xpos(la,i)-xpos_old(la,i)
     .           +force(la,i)*dt**2
          xvel(la,i)=(xpos_new(la,i)-xpos_old(la,i))/(2*dt)
          ekin=ekin+xvel(la,i)**2
          if(xpos_new(la,i).gt.ell) then
             xpos_new(la,i)=xpos_new(la,i)-ell
             xpos(la,i)=xpos(la,i)-ell
             xpos_old(la,i)=xpos_old(la,i)-ell
          else if(xpos_new(la,i).lt.0) then
             xpos_new(la,i)=xpos_new(la,i)+ell
             xpos(la,i)=xpos(la,i)+ell
             xpos_old(la,i)=xpos_old(la,i)+ell
          end if
        end do
      end do
      temperature_act=ekin/dfloat(ndim*nparts)
      ekin=ekin/2.d0
      end
